/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	v1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis/kumori/v1"
	"gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/generated/clientset/versioned/scheme"
	rest "k8s.io/client-go/rest"
)

type KumoriV1Interface interface {
	RESTClient() rest.Interface
	KukuCNsGetter
	KukuCertsGetter
	KukuComponentsGetter
	KukuDeploymentsGetter
	KukuHttpInboundsGetter
	KukuLinksGetter
	KukuPersistentVolumesGetter
	KukuServicesGetter
	KukuVHostsGetter
	V3DeploymentsGetter
}

// KumoriV1Client is used to interact with features provided by the kumori.systems group.
type KumoriV1Client struct {
	restClient rest.Interface
}

func (c *KumoriV1Client) KukuCNs(namespace string) KukuCNInterface {
	return newKukuCNs(c, namespace)
}

func (c *KumoriV1Client) KukuCerts(namespace string) KukuCertInterface {
	return newKukuCerts(c, namespace)
}

func (c *KumoriV1Client) KukuComponents(namespace string) KukuComponentInterface {
	return newKukuComponents(c, namespace)
}

func (c *KumoriV1Client) KukuDeployments(namespace string) KukuDeploymentInterface {
	return newKukuDeployments(c, namespace)
}

func (c *KumoriV1Client) KukuHttpInbounds(namespace string) KukuHttpInboundInterface {
	return newKukuHttpInbounds(c, namespace)
}

func (c *KumoriV1Client) KukuLinks(namespace string) KukuLinkInterface {
	return newKukuLinks(c, namespace)
}

func (c *KumoriV1Client) KukuPersistentVolumes(namespace string) KukuPersistentVolumeInterface {
	return newKukuPersistentVolumes(c, namespace)
}

func (c *KumoriV1Client) KukuServices(namespace string) KukuServiceInterface {
	return newKukuServices(c, namespace)
}

func (c *KumoriV1Client) KukuVHosts(namespace string) KukuVHostInterface {
	return newKukuVHosts(c, namespace)
}

func (c *KumoriV1Client) V3Deployments(namespace string) V3DeploymentInterface {
	return newV3Deployments(c, namespace)
}

// NewForConfig creates a new KumoriV1Client for the given config.
func NewForConfig(c *rest.Config) (*KumoriV1Client, error) {
	config := *c
	if err := setConfigDefaults(&config); err != nil {
		return nil, err
	}
	client, err := rest.RESTClientFor(&config)
	if err != nil {
		return nil, err
	}
	return &KumoriV1Client{client}, nil
}

// NewForConfigOrDie creates a new KumoriV1Client for the given config and
// panics if there is an error in the config.
func NewForConfigOrDie(c *rest.Config) *KumoriV1Client {
	client, err := NewForConfig(c)
	if err != nil {
		panic(err)
	}
	return client
}

// New creates a new KumoriV1Client for the given RESTClient.
func New(c rest.Interface) *KumoriV1Client {
	return &KumoriV1Client{c}
}

func setConfigDefaults(config *rest.Config) error {
	gv := v1.SchemeGroupVersion
	config.GroupVersion = &gv
	config.APIPath = "/apis"
	config.NegotiatedSerializer = scheme.Codecs.WithoutConversion()

	if config.UserAgent == "" {
		config.UserAgent = rest.DefaultKubernetesUserAgent()
	}

	return nil
}

// RESTClient returns a RESTClient that is used to communicate
// with API server by this client implementation.
func (c *KumoriV1Client) RESTClient() rest.Interface {
	if c == nil {
		return nil
	}
	return c.restClient
}
